// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package appconfig

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
	"github.com/aws/aws-sdk-go-v2-0.24/private/protocol"
)

type ListHostedConfigurationVersionsInput struct {
	_ struct{} `type:"structure"`

	// The application ID.
	//
	// ApplicationId is a required field
	ApplicationId *string `location:"uri" locationName:"ApplicationId" type:"string" required:"true"`

	// The configuration profile ID.
	//
	// ConfigurationProfileId is a required field
	ConfigurationProfileId *string `location:"uri" locationName:"ConfigurationProfileId" type:"string" required:"true"`

	// The maximum number of items to return for this call. The call also returns
	// a token that you can specify in a subsequent call to get the next set of
	// results.
	MaxResults *int64 `location:"querystring" locationName:"max_results" min:"1" type:"integer"`

	// A token to start the list. Use this token to get the next set of results.
	NextToken *string `location:"querystring" locationName:"next_token" min:"1" type:"string"`
}

// String returns the string representation
func (s ListHostedConfigurationVersionsInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListHostedConfigurationVersionsInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "ListHostedConfigurationVersionsInput"}

	if s.ApplicationId == nil {
		invalidParams.Add(aws.NewErrParamRequired("ApplicationId"))
	}

	if s.ConfigurationProfileId == nil {
		invalidParams.Add(aws.NewErrParamRequired("ConfigurationProfileId"))
	}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(aws.NewErrParamMinValue("MaxResults", 1))
	}
	if s.NextToken != nil && len(*s.NextToken) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("NextToken", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s ListHostedConfigurationVersionsInput) MarshalFields(e protocol.FieldEncoder) error {
	e.SetValue(protocol.HeaderTarget, "Content-Type", protocol.StringValue("application/json"), protocol.Metadata{})

	if s.ApplicationId != nil {
		v := *s.ApplicationId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "ApplicationId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.ConfigurationProfileId != nil {
		v := *s.ConfigurationProfileId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "ConfigurationProfileId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.MaxResults != nil {
		v := *s.MaxResults

		metadata := protocol.Metadata{}
		e.SetValue(protocol.QueryTarget, "max_results", protocol.Int64Value(v), metadata)
	}
	if s.NextToken != nil {
		v := *s.NextToken

		metadata := protocol.Metadata{}
		e.SetValue(protocol.QueryTarget, "next_token", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

type ListHostedConfigurationVersionsOutput struct {
	_ struct{} `type:"structure"`

	// The elements from this collection.
	Items []HostedConfigurationVersionSummary `type:"list"`

	// The token for the next set of items to return. Use this token to get the
	// next set of results.
	NextToken *string `min:"1" type:"string"`
}

// String returns the string representation
func (s ListHostedConfigurationVersionsOutput) String() string {
	return awsutil.Prettify(s)
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s ListHostedConfigurationVersionsOutput) MarshalFields(e protocol.FieldEncoder) error {
	if s.Items != nil {
		v := s.Items

		metadata := protocol.Metadata{}
		ls0 := e.List(protocol.BodyTarget, "Items", metadata)
		ls0.Start()
		for _, v1 := range v {
			ls0.ListAddFields(v1)
		}
		ls0.End()

	}
	if s.NextToken != nil {
		v := *s.NextToken

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "NextToken", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

const opListHostedConfigurationVersions = "ListHostedConfigurationVersions"

// ListHostedConfigurationVersionsRequest returns a request value for making API operation for
// Amazon AppConfig.
//
// View a list of configurations stored in the AppConfig configuration store
// by version.
//
//    // Example sending a request using ListHostedConfigurationVersionsRequest.
//    req := client.ListHostedConfigurationVersionsRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/appconfig-2019-10-09/ListHostedConfigurationVersions
func (c *Client) ListHostedConfigurationVersionsRequest(input *ListHostedConfigurationVersionsInput) ListHostedConfigurationVersionsRequest {
	op := &aws.Operation{
		Name:       opListHostedConfigurationVersions,
		HTTPMethod: "GET",
		HTTPPath:   "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions",
		Paginator: &aws.Paginator{
			InputTokens:     []string{"NextToken"},
			OutputTokens:    []string{"NextToken"},
			LimitToken:      "MaxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListHostedConfigurationVersionsInput{}
	}

	req := c.newRequest(op, input, &ListHostedConfigurationVersionsOutput{})

	return ListHostedConfigurationVersionsRequest{Request: req, Input: input, Copy: c.ListHostedConfigurationVersionsRequest}
}

// ListHostedConfigurationVersionsRequest is the request type for the
// ListHostedConfigurationVersions API operation.
type ListHostedConfigurationVersionsRequest struct {
	*aws.Request
	Input *ListHostedConfigurationVersionsInput
	Copy  func(*ListHostedConfigurationVersionsInput) ListHostedConfigurationVersionsRequest
}

// Send marshals and sends the ListHostedConfigurationVersions API request.
func (r ListHostedConfigurationVersionsRequest) Send(ctx context.Context) (*ListHostedConfigurationVersionsResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &ListHostedConfigurationVersionsResponse{
		ListHostedConfigurationVersionsOutput: r.Request.Data.(*ListHostedConfigurationVersionsOutput),
		response:                              &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// NewListHostedConfigurationVersionsRequestPaginator returns a paginator for ListHostedConfigurationVersions.
// Use Next method to get the next page, and CurrentPage to get the current
// response page from the paginator. Next will return false, if there are
// no more pages, or an error was encountered.
//
// Note: This operation can generate multiple requests to a service.
//
//   // Example iterating over pages.
//   req := client.ListHostedConfigurationVersionsRequest(input)
//   p := appconfig.NewListHostedConfigurationVersionsRequestPaginator(req)
//
//   for p.Next(context.TODO()) {
//       page := p.CurrentPage()
//   }
//
//   if err := p.Err(); err != nil {
//       return err
//   }
//
func NewListHostedConfigurationVersionsPaginator(req ListHostedConfigurationVersionsRequest) ListHostedConfigurationVersionsPaginator {
	return ListHostedConfigurationVersionsPaginator{
		Pager: aws.Pager{
			NewRequest: func(ctx context.Context) (*aws.Request, error) {
				var inCpy *ListHostedConfigurationVersionsInput
				if req.Input != nil {
					tmp := *req.Input
					inCpy = &tmp
				}

				newReq := req.Copy(inCpy)
				newReq.SetContext(ctx)
				return newReq.Request, nil
			},
		},
	}
}

// ListHostedConfigurationVersionsPaginator is used to paginate the request. This can be done by
// calling Next and CurrentPage.
type ListHostedConfigurationVersionsPaginator struct {
	aws.Pager
}

func (p *ListHostedConfigurationVersionsPaginator) CurrentPage() *ListHostedConfigurationVersionsOutput {
	return p.Pager.CurrentPage().(*ListHostedConfigurationVersionsOutput)
}

// ListHostedConfigurationVersionsResponse is the response type for the
// ListHostedConfigurationVersions API operation.
type ListHostedConfigurationVersionsResponse struct {
	*ListHostedConfigurationVersionsOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// ListHostedConfigurationVersions request.
func (r *ListHostedConfigurationVersionsResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
