// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package appmesh

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
	"github.com/aws/aws-sdk-go-v2-0.24/private/protocol"
)

type DeleteVirtualGatewayInput struct {
	_ struct{} `type:"structure"`

	// MeshName is a required field
	MeshName *string `location:"uri" locationName:"meshName" min:"1" type:"string" required:"true"`

	MeshOwner *string `location:"querystring" locationName:"meshOwner" min:"12" type:"string"`

	// VirtualGatewayName is a required field
	VirtualGatewayName *string `location:"uri" locationName:"virtualGatewayName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteVirtualGatewayInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteVirtualGatewayInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "DeleteVirtualGatewayInput"}

	if s.MeshName == nil {
		invalidParams.Add(aws.NewErrParamRequired("MeshName"))
	}
	if s.MeshName != nil && len(*s.MeshName) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("MeshName", 1))
	}
	if s.MeshOwner != nil && len(*s.MeshOwner) < 12 {
		invalidParams.Add(aws.NewErrParamMinLen("MeshOwner", 12))
	}

	if s.VirtualGatewayName == nil {
		invalidParams.Add(aws.NewErrParamRequired("VirtualGatewayName"))
	}
	if s.VirtualGatewayName != nil && len(*s.VirtualGatewayName) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("VirtualGatewayName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s DeleteVirtualGatewayInput) MarshalFields(e protocol.FieldEncoder) error {
	e.SetValue(protocol.HeaderTarget, "Content-Type", protocol.StringValue("application/json"), protocol.Metadata{})

	if s.MeshName != nil {
		v := *s.MeshName

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "meshName", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.VirtualGatewayName != nil {
		v := *s.VirtualGatewayName

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "virtualGatewayName", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.MeshOwner != nil {
		v := *s.MeshOwner

		metadata := protocol.Metadata{}
		e.SetValue(protocol.QueryTarget, "meshOwner", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

type DeleteVirtualGatewayOutput struct {
	_ struct{} `type:"structure" payload:"VirtualGateway"`

	// An object that represents a virtual gateway returned by a describe operation.
	//
	// VirtualGateway is a required field
	VirtualGateway *VirtualGatewayData `locationName:"virtualGateway" type:"structure" required:"true"`
}

// String returns the string representation
func (s DeleteVirtualGatewayOutput) String() string {
	return awsutil.Prettify(s)
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s DeleteVirtualGatewayOutput) MarshalFields(e protocol.FieldEncoder) error {
	if s.VirtualGateway != nil {
		v := s.VirtualGateway

		metadata := protocol.Metadata{}
		e.SetFields(protocol.PayloadTarget, "virtualGateway", v, metadata)
	}
	return nil
}

const opDeleteVirtualGateway = "DeleteVirtualGateway"

// DeleteVirtualGatewayRequest returns a request value for making API operation for
// AWS App Mesh.
//
// Deletes an existing virtual gateway. You cannot delete a virtual gateway
// if any gateway routes are associated to it.
//
//    // Example sending a request using DeleteVirtualGatewayRequest.
//    req := client.DeleteVirtualGatewayRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/appmesh-2019-01-25/DeleteVirtualGateway
func (c *Client) DeleteVirtualGatewayRequest(input *DeleteVirtualGatewayInput) DeleteVirtualGatewayRequest {
	op := &aws.Operation{
		Name:       opDeleteVirtualGateway,
		HTTPMethod: "DELETE",
		HTTPPath:   "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
	}

	if input == nil {
		input = &DeleteVirtualGatewayInput{}
	}

	req := c.newRequest(op, input, &DeleteVirtualGatewayOutput{})

	return DeleteVirtualGatewayRequest{Request: req, Input: input, Copy: c.DeleteVirtualGatewayRequest}
}

// DeleteVirtualGatewayRequest is the request type for the
// DeleteVirtualGateway API operation.
type DeleteVirtualGatewayRequest struct {
	*aws.Request
	Input *DeleteVirtualGatewayInput
	Copy  func(*DeleteVirtualGatewayInput) DeleteVirtualGatewayRequest
}

// Send marshals and sends the DeleteVirtualGateway API request.
func (r DeleteVirtualGatewayRequest) Send(ctx context.Context) (*DeleteVirtualGatewayResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &DeleteVirtualGatewayResponse{
		DeleteVirtualGatewayOutput: r.Request.Data.(*DeleteVirtualGatewayOutput),
		response:                   &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// DeleteVirtualGatewayResponse is the response type for the
// DeleteVirtualGateway API operation.
type DeleteVirtualGatewayResponse struct {
	*DeleteVirtualGatewayOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// DeleteVirtualGateway request.
func (r *DeleteVirtualGatewayResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
