// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package autoscaling

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
)

type DescribeAdjustmentTypesInput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s DescribeAdjustmentTypesInput) String() string {
	return awsutil.Prettify(s)
}

type DescribeAdjustmentTypesOutput struct {
	_ struct{} `type:"structure"`

	// The policy adjustment types.
	AdjustmentTypes []AdjustmentType `type:"list"`
}

// String returns the string representation
func (s DescribeAdjustmentTypesOutput) String() string {
	return awsutil.Prettify(s)
}

const opDescribeAdjustmentTypes = "DescribeAdjustmentTypes"

// DescribeAdjustmentTypesRequest returns a request value for making API operation for
// Auto Scaling.
//
// Describes the available adjustment types for Amazon EC2 Auto Scaling scaling
// policies. These settings apply to step scaling policies and simple scaling
// policies; they do not apply to target tracking scaling policies.
//
// The following adjustment types are supported:
//
//    * ChangeInCapacity
//
//    * ExactCapacity
//
//    * PercentChangeInCapacity
//
//    // Example sending a request using DescribeAdjustmentTypesRequest.
//    req := client.DescribeAdjustmentTypesRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/autoscaling-2011-01-01/DescribeAdjustmentTypes
func (c *Client) DescribeAdjustmentTypesRequest(input *DescribeAdjustmentTypesInput) DescribeAdjustmentTypesRequest {
	op := &aws.Operation{
		Name:       opDescribeAdjustmentTypes,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DescribeAdjustmentTypesInput{}
	}

	req := c.newRequest(op, input, &DescribeAdjustmentTypesOutput{})

	return DescribeAdjustmentTypesRequest{Request: req, Input: input, Copy: c.DescribeAdjustmentTypesRequest}
}

// DescribeAdjustmentTypesRequest is the request type for the
// DescribeAdjustmentTypes API operation.
type DescribeAdjustmentTypesRequest struct {
	*aws.Request
	Input *DescribeAdjustmentTypesInput
	Copy  func(*DescribeAdjustmentTypesInput) DescribeAdjustmentTypesRequest
}

// Send marshals and sends the DescribeAdjustmentTypes API request.
func (r DescribeAdjustmentTypesRequest) Send(ctx context.Context) (*DescribeAdjustmentTypesResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &DescribeAdjustmentTypesResponse{
		DescribeAdjustmentTypesOutput: r.Request.Data.(*DescribeAdjustmentTypesOutput),
		response:                      &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// DescribeAdjustmentTypesResponse is the response type for the
// DescribeAdjustmentTypes API operation.
type DescribeAdjustmentTypesResponse struct {
	*DescribeAdjustmentTypesOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// DescribeAdjustmentTypes request.
func (r *DescribeAdjustmentTypesResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
