// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package chimeiface provides an interface to enable mocking the Amazon Chime service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package chimeiface

import (
	"github.com/aws/aws-sdk-go-v2-0.24/service/chime"
)

// ClientAPI provides an interface to enable mocking the
// chime.Client methods. This make unit testing your code that
// calls out to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // Amazon Chime.
//    func myFunc(svc chimeiface.ClientAPI) bool {
//        // Make svc.AssociatePhoneNumberWithUser request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := chime.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockClientClient struct {
//        chimeiface.ClientPI
//    }
//    func (m *mockClientClient) AssociatePhoneNumberWithUser(input *chime.AssociatePhoneNumberWithUserInput) (*chime.AssociatePhoneNumberWithUserOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockClientClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type ClientAPI interface {
	AssociatePhoneNumberWithUserRequest(*chime.AssociatePhoneNumberWithUserInput) chime.AssociatePhoneNumberWithUserRequest

	AssociatePhoneNumbersWithVoiceConnectorRequest(*chime.AssociatePhoneNumbersWithVoiceConnectorInput) chime.AssociatePhoneNumbersWithVoiceConnectorRequest

	AssociatePhoneNumbersWithVoiceConnectorGroupRequest(*chime.AssociatePhoneNumbersWithVoiceConnectorGroupInput) chime.AssociatePhoneNumbersWithVoiceConnectorGroupRequest

	AssociateSigninDelegateGroupsWithAccountRequest(*chime.AssociateSigninDelegateGroupsWithAccountInput) chime.AssociateSigninDelegateGroupsWithAccountRequest

	BatchCreateAttendeeRequest(*chime.BatchCreateAttendeeInput) chime.BatchCreateAttendeeRequest

	BatchCreateRoomMembershipRequest(*chime.BatchCreateRoomMembershipInput) chime.BatchCreateRoomMembershipRequest

	BatchDeletePhoneNumberRequest(*chime.BatchDeletePhoneNumberInput) chime.BatchDeletePhoneNumberRequest

	BatchSuspendUserRequest(*chime.BatchSuspendUserInput) chime.BatchSuspendUserRequest

	BatchUnsuspendUserRequest(*chime.BatchUnsuspendUserInput) chime.BatchUnsuspendUserRequest

	BatchUpdatePhoneNumberRequest(*chime.BatchUpdatePhoneNumberInput) chime.BatchUpdatePhoneNumberRequest

	BatchUpdateUserRequest(*chime.BatchUpdateUserInput) chime.BatchUpdateUserRequest

	CreateAccountRequest(*chime.CreateAccountInput) chime.CreateAccountRequest

	CreateAttendeeRequest(*chime.CreateAttendeeInput) chime.CreateAttendeeRequest

	CreateBotRequest(*chime.CreateBotInput) chime.CreateBotRequest

	CreateMeetingRequest(*chime.CreateMeetingInput) chime.CreateMeetingRequest

	CreateMeetingWithAttendeesRequest(*chime.CreateMeetingWithAttendeesInput) chime.CreateMeetingWithAttendeesRequest

	CreatePhoneNumberOrderRequest(*chime.CreatePhoneNumberOrderInput) chime.CreatePhoneNumberOrderRequest

	CreateProxySessionRequest(*chime.CreateProxySessionInput) chime.CreateProxySessionRequest

	CreateRoomRequest(*chime.CreateRoomInput) chime.CreateRoomRequest

	CreateRoomMembershipRequest(*chime.CreateRoomMembershipInput) chime.CreateRoomMembershipRequest

	CreateUserRequest(*chime.CreateUserInput) chime.CreateUserRequest

	CreateVoiceConnectorRequest(*chime.CreateVoiceConnectorInput) chime.CreateVoiceConnectorRequest

	CreateVoiceConnectorGroupRequest(*chime.CreateVoiceConnectorGroupInput) chime.CreateVoiceConnectorGroupRequest

	DeleteAccountRequest(*chime.DeleteAccountInput) chime.DeleteAccountRequest

	DeleteAttendeeRequest(*chime.DeleteAttendeeInput) chime.DeleteAttendeeRequest

	DeleteEventsConfigurationRequest(*chime.DeleteEventsConfigurationInput) chime.DeleteEventsConfigurationRequest

	DeleteMeetingRequest(*chime.DeleteMeetingInput) chime.DeleteMeetingRequest

	DeletePhoneNumberRequest(*chime.DeletePhoneNumberInput) chime.DeletePhoneNumberRequest

	DeleteProxySessionRequest(*chime.DeleteProxySessionInput) chime.DeleteProxySessionRequest

	DeleteRoomRequest(*chime.DeleteRoomInput) chime.DeleteRoomRequest

	DeleteRoomMembershipRequest(*chime.DeleteRoomMembershipInput) chime.DeleteRoomMembershipRequest

	DeleteVoiceConnectorRequest(*chime.DeleteVoiceConnectorInput) chime.DeleteVoiceConnectorRequest

	DeleteVoiceConnectorEmergencyCallingConfigurationRequest(*chime.DeleteVoiceConnectorEmergencyCallingConfigurationInput) chime.DeleteVoiceConnectorEmergencyCallingConfigurationRequest

	DeleteVoiceConnectorGroupRequest(*chime.DeleteVoiceConnectorGroupInput) chime.DeleteVoiceConnectorGroupRequest

	DeleteVoiceConnectorOriginationRequest(*chime.DeleteVoiceConnectorOriginationInput) chime.DeleteVoiceConnectorOriginationRequest

	DeleteVoiceConnectorProxyRequest(*chime.DeleteVoiceConnectorProxyInput) chime.DeleteVoiceConnectorProxyRequest

	DeleteVoiceConnectorStreamingConfigurationRequest(*chime.DeleteVoiceConnectorStreamingConfigurationInput) chime.DeleteVoiceConnectorStreamingConfigurationRequest

	DeleteVoiceConnectorTerminationRequest(*chime.DeleteVoiceConnectorTerminationInput) chime.DeleteVoiceConnectorTerminationRequest

	DeleteVoiceConnectorTerminationCredentialsRequest(*chime.DeleteVoiceConnectorTerminationCredentialsInput) chime.DeleteVoiceConnectorTerminationCredentialsRequest

	DisassociatePhoneNumberFromUserRequest(*chime.DisassociatePhoneNumberFromUserInput) chime.DisassociatePhoneNumberFromUserRequest

	DisassociatePhoneNumbersFromVoiceConnectorRequest(*chime.DisassociatePhoneNumbersFromVoiceConnectorInput) chime.DisassociatePhoneNumbersFromVoiceConnectorRequest

	DisassociatePhoneNumbersFromVoiceConnectorGroupRequest(*chime.DisassociatePhoneNumbersFromVoiceConnectorGroupInput) chime.DisassociatePhoneNumbersFromVoiceConnectorGroupRequest

	DisassociateSigninDelegateGroupsFromAccountRequest(*chime.DisassociateSigninDelegateGroupsFromAccountInput) chime.DisassociateSigninDelegateGroupsFromAccountRequest

	GetAccountRequest(*chime.GetAccountInput) chime.GetAccountRequest

	GetAccountSettingsRequest(*chime.GetAccountSettingsInput) chime.GetAccountSettingsRequest

	GetAttendeeRequest(*chime.GetAttendeeInput) chime.GetAttendeeRequest

	GetBotRequest(*chime.GetBotInput) chime.GetBotRequest

	GetEventsConfigurationRequest(*chime.GetEventsConfigurationInput) chime.GetEventsConfigurationRequest

	GetGlobalSettingsRequest(*chime.GetGlobalSettingsInput) chime.GetGlobalSettingsRequest

	GetMeetingRequest(*chime.GetMeetingInput) chime.GetMeetingRequest

	GetPhoneNumberRequest(*chime.GetPhoneNumberInput) chime.GetPhoneNumberRequest

	GetPhoneNumberOrderRequest(*chime.GetPhoneNumberOrderInput) chime.GetPhoneNumberOrderRequest

	GetPhoneNumberSettingsRequest(*chime.GetPhoneNumberSettingsInput) chime.GetPhoneNumberSettingsRequest

	GetProxySessionRequest(*chime.GetProxySessionInput) chime.GetProxySessionRequest

	GetRetentionSettingsRequest(*chime.GetRetentionSettingsInput) chime.GetRetentionSettingsRequest

	GetRoomRequest(*chime.GetRoomInput) chime.GetRoomRequest

	GetUserRequest(*chime.GetUserInput) chime.GetUserRequest

	GetUserSettingsRequest(*chime.GetUserSettingsInput) chime.GetUserSettingsRequest

	GetVoiceConnectorRequest(*chime.GetVoiceConnectorInput) chime.GetVoiceConnectorRequest

	GetVoiceConnectorEmergencyCallingConfigurationRequest(*chime.GetVoiceConnectorEmergencyCallingConfigurationInput) chime.GetVoiceConnectorEmergencyCallingConfigurationRequest

	GetVoiceConnectorGroupRequest(*chime.GetVoiceConnectorGroupInput) chime.GetVoiceConnectorGroupRequest

	GetVoiceConnectorLoggingConfigurationRequest(*chime.GetVoiceConnectorLoggingConfigurationInput) chime.GetVoiceConnectorLoggingConfigurationRequest

	GetVoiceConnectorOriginationRequest(*chime.GetVoiceConnectorOriginationInput) chime.GetVoiceConnectorOriginationRequest

	GetVoiceConnectorProxyRequest(*chime.GetVoiceConnectorProxyInput) chime.GetVoiceConnectorProxyRequest

	GetVoiceConnectorStreamingConfigurationRequest(*chime.GetVoiceConnectorStreamingConfigurationInput) chime.GetVoiceConnectorStreamingConfigurationRequest

	GetVoiceConnectorTerminationRequest(*chime.GetVoiceConnectorTerminationInput) chime.GetVoiceConnectorTerminationRequest

	GetVoiceConnectorTerminationHealthRequest(*chime.GetVoiceConnectorTerminationHealthInput) chime.GetVoiceConnectorTerminationHealthRequest

	InviteUsersRequest(*chime.InviteUsersInput) chime.InviteUsersRequest

	ListAccountsRequest(*chime.ListAccountsInput) chime.ListAccountsRequest

	ListAttendeeTagsRequest(*chime.ListAttendeeTagsInput) chime.ListAttendeeTagsRequest

	ListAttendeesRequest(*chime.ListAttendeesInput) chime.ListAttendeesRequest

	ListBotsRequest(*chime.ListBotsInput) chime.ListBotsRequest

	ListMeetingTagsRequest(*chime.ListMeetingTagsInput) chime.ListMeetingTagsRequest

	ListMeetingsRequest(*chime.ListMeetingsInput) chime.ListMeetingsRequest

	ListPhoneNumberOrdersRequest(*chime.ListPhoneNumberOrdersInput) chime.ListPhoneNumberOrdersRequest

	ListPhoneNumbersRequest(*chime.ListPhoneNumbersInput) chime.ListPhoneNumbersRequest

	ListProxySessionsRequest(*chime.ListProxySessionsInput) chime.ListProxySessionsRequest

	ListRoomMembershipsRequest(*chime.ListRoomMembershipsInput) chime.ListRoomMembershipsRequest

	ListRoomsRequest(*chime.ListRoomsInput) chime.ListRoomsRequest

	ListTagsForResourceRequest(*chime.ListTagsForResourceInput) chime.ListTagsForResourceRequest

	ListUsersRequest(*chime.ListUsersInput) chime.ListUsersRequest

	ListVoiceConnectorGroupsRequest(*chime.ListVoiceConnectorGroupsInput) chime.ListVoiceConnectorGroupsRequest

	ListVoiceConnectorTerminationCredentialsRequest(*chime.ListVoiceConnectorTerminationCredentialsInput) chime.ListVoiceConnectorTerminationCredentialsRequest

	ListVoiceConnectorsRequest(*chime.ListVoiceConnectorsInput) chime.ListVoiceConnectorsRequest

	LogoutUserRequest(*chime.LogoutUserInput) chime.LogoutUserRequest

	PutEventsConfigurationRequest(*chime.PutEventsConfigurationInput) chime.PutEventsConfigurationRequest

	PutRetentionSettingsRequest(*chime.PutRetentionSettingsInput) chime.PutRetentionSettingsRequest

	PutVoiceConnectorEmergencyCallingConfigurationRequest(*chime.PutVoiceConnectorEmergencyCallingConfigurationInput) chime.PutVoiceConnectorEmergencyCallingConfigurationRequest

	PutVoiceConnectorLoggingConfigurationRequest(*chime.PutVoiceConnectorLoggingConfigurationInput) chime.PutVoiceConnectorLoggingConfigurationRequest

	PutVoiceConnectorOriginationRequest(*chime.PutVoiceConnectorOriginationInput) chime.PutVoiceConnectorOriginationRequest

	PutVoiceConnectorProxyRequest(*chime.PutVoiceConnectorProxyInput) chime.PutVoiceConnectorProxyRequest

	PutVoiceConnectorStreamingConfigurationRequest(*chime.PutVoiceConnectorStreamingConfigurationInput) chime.PutVoiceConnectorStreamingConfigurationRequest

	PutVoiceConnectorTerminationRequest(*chime.PutVoiceConnectorTerminationInput) chime.PutVoiceConnectorTerminationRequest

	PutVoiceConnectorTerminationCredentialsRequest(*chime.PutVoiceConnectorTerminationCredentialsInput) chime.PutVoiceConnectorTerminationCredentialsRequest

	RedactConversationMessageRequest(*chime.RedactConversationMessageInput) chime.RedactConversationMessageRequest

	RedactRoomMessageRequest(*chime.RedactRoomMessageInput) chime.RedactRoomMessageRequest

	RegenerateSecurityTokenRequest(*chime.RegenerateSecurityTokenInput) chime.RegenerateSecurityTokenRequest

	ResetPersonalPINRequest(*chime.ResetPersonalPINInput) chime.ResetPersonalPINRequest

	RestorePhoneNumberRequest(*chime.RestorePhoneNumberInput) chime.RestorePhoneNumberRequest

	SearchAvailablePhoneNumbersRequest(*chime.SearchAvailablePhoneNumbersInput) chime.SearchAvailablePhoneNumbersRequest

	TagAttendeeRequest(*chime.TagAttendeeInput) chime.TagAttendeeRequest

	TagMeetingRequest(*chime.TagMeetingInput) chime.TagMeetingRequest

	TagResourceRequest(*chime.TagResourceInput) chime.TagResourceRequest

	UntagAttendeeRequest(*chime.UntagAttendeeInput) chime.UntagAttendeeRequest

	UntagMeetingRequest(*chime.UntagMeetingInput) chime.UntagMeetingRequest

	UntagResourceRequest(*chime.UntagResourceInput) chime.UntagResourceRequest

	UpdateAccountRequest(*chime.UpdateAccountInput) chime.UpdateAccountRequest

	UpdateAccountSettingsRequest(*chime.UpdateAccountSettingsInput) chime.UpdateAccountSettingsRequest

	UpdateBotRequest(*chime.UpdateBotInput) chime.UpdateBotRequest

	UpdateGlobalSettingsRequest(*chime.UpdateGlobalSettingsInput) chime.UpdateGlobalSettingsRequest

	UpdatePhoneNumberRequest(*chime.UpdatePhoneNumberInput) chime.UpdatePhoneNumberRequest

	UpdatePhoneNumberSettingsRequest(*chime.UpdatePhoneNumberSettingsInput) chime.UpdatePhoneNumberSettingsRequest

	UpdateProxySessionRequest(*chime.UpdateProxySessionInput) chime.UpdateProxySessionRequest

	UpdateRoomRequest(*chime.UpdateRoomInput) chime.UpdateRoomRequest

	UpdateRoomMembershipRequest(*chime.UpdateRoomMembershipInput) chime.UpdateRoomMembershipRequest

	UpdateUserRequest(*chime.UpdateUserInput) chime.UpdateUserRequest

	UpdateUserSettingsRequest(*chime.UpdateUserSettingsInput) chime.UpdateUserSettingsRequest

	UpdateVoiceConnectorRequest(*chime.UpdateVoiceConnectorInput) chime.UpdateVoiceConnectorRequest

	UpdateVoiceConnectorGroupRequest(*chime.UpdateVoiceConnectorGroupInput) chime.UpdateVoiceConnectorGroupRequest
}

var _ ClientAPI = (*chime.Client)(nil)
