// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package configservice

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
)

type GetComplianceSummaryByConfigRuleInput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s GetComplianceSummaryByConfigRuleInput) String() string {
	return awsutil.Prettify(s)
}

type GetComplianceSummaryByConfigRuleOutput struct {
	_ struct{} `type:"structure"`

	// The number of AWS Config rules that are compliant and the number that are
	// noncompliant, up to a maximum of 25 for each.
	ComplianceSummary *ComplianceSummary `type:"structure"`
}

// String returns the string representation
func (s GetComplianceSummaryByConfigRuleOutput) String() string {
	return awsutil.Prettify(s)
}

const opGetComplianceSummaryByConfigRule = "GetComplianceSummaryByConfigRule"

// GetComplianceSummaryByConfigRuleRequest returns a request value for making API operation for
// AWS Config.
//
// Returns the number of AWS Config rules that are compliant and noncompliant,
// up to a maximum of 25 for each.
//
//    // Example sending a request using GetComplianceSummaryByConfigRuleRequest.
//    req := client.GetComplianceSummaryByConfigRuleRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/config-2014-11-12/GetComplianceSummaryByConfigRule
func (c *Client) GetComplianceSummaryByConfigRuleRequest(input *GetComplianceSummaryByConfigRuleInput) GetComplianceSummaryByConfigRuleRequest {
	op := &aws.Operation{
		Name:       opGetComplianceSummaryByConfigRule,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetComplianceSummaryByConfigRuleInput{}
	}

	req := c.newRequest(op, input, &GetComplianceSummaryByConfigRuleOutput{})

	return GetComplianceSummaryByConfigRuleRequest{Request: req, Input: input, Copy: c.GetComplianceSummaryByConfigRuleRequest}
}

// GetComplianceSummaryByConfigRuleRequest is the request type for the
// GetComplianceSummaryByConfigRule API operation.
type GetComplianceSummaryByConfigRuleRequest struct {
	*aws.Request
	Input *GetComplianceSummaryByConfigRuleInput
	Copy  func(*GetComplianceSummaryByConfigRuleInput) GetComplianceSummaryByConfigRuleRequest
}

// Send marshals and sends the GetComplianceSummaryByConfigRule API request.
func (r GetComplianceSummaryByConfigRuleRequest) Send(ctx context.Context) (*GetComplianceSummaryByConfigRuleResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &GetComplianceSummaryByConfigRuleResponse{
		GetComplianceSummaryByConfigRuleOutput: r.Request.Data.(*GetComplianceSummaryByConfigRuleOutput),
		response:                               &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// GetComplianceSummaryByConfigRuleResponse is the response type for the
// GetComplianceSummaryByConfigRule API operation.
type GetComplianceSummaryByConfigRuleResponse struct {
	*GetComplianceSummaryByConfigRuleOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// GetComplianceSummaryByConfigRule request.
func (r *GetComplianceSummaryByConfigRuleResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
