// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package docdb

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
)

// Represents the input to ModifyDBClusterSnapshotAttribute.
type ModifyDBClusterSnapshotAttributeInput struct {
	_ struct{} `type:"structure"`

	// The name of the cluster snapshot attribute to modify.
	//
	// To manage authorization for other AWS accounts to copy or restore a manual
	// cluster snapshot, set this value to restore.
	//
	// AttributeName is a required field
	AttributeName *string `type:"string" required:"true"`

	// The identifier for the cluster snapshot to modify the attributes for.
	//
	// DBClusterSnapshotIdentifier is a required field
	DBClusterSnapshotIdentifier *string `type:"string" required:"true"`

	// A list of cluster snapshot attributes to add to the attribute specified by
	// AttributeName.
	//
	// To authorize other AWS accounts to copy or restore a manual cluster snapshot,
	// set this list to include one or more AWS account IDs. To make the manual
	// cluster snapshot restorable by any AWS account, set it to all. Do not add
	// the all value for any manual cluster snapshots that contain private information
	// that you don't want to be available to all AWS accounts.
	ValuesToAdd []string `locationNameList:"AttributeValue" type:"list"`

	// A list of cluster snapshot attributes to remove from the attribute specified
	// by AttributeName.
	//
	// To remove authorization for other AWS accounts to copy or restore a manual
	// cluster snapshot, set this list to include one or more AWS account identifiers.
	// To remove authorization for any AWS account to copy or restore the cluster
	// snapshot, set it to all . If you specify all, an AWS account whose account
	// ID is explicitly added to the restore attribute can still copy or restore
	// a manual cluster snapshot.
	ValuesToRemove []string `locationNameList:"AttributeValue" type:"list"`
}

// String returns the string representation
func (s ModifyDBClusterSnapshotAttributeInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ModifyDBClusterSnapshotAttributeInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "ModifyDBClusterSnapshotAttributeInput"}

	if s.AttributeName == nil {
		invalidParams.Add(aws.NewErrParamRequired("AttributeName"))
	}

	if s.DBClusterSnapshotIdentifier == nil {
		invalidParams.Add(aws.NewErrParamRequired("DBClusterSnapshotIdentifier"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

type ModifyDBClusterSnapshotAttributeOutput struct {
	_ struct{} `type:"structure"`

	// Detailed information about the attributes that are associated with a cluster
	// snapshot.
	DBClusterSnapshotAttributesResult *DBClusterSnapshotAttributesResult `type:"structure"`
}

// String returns the string representation
func (s ModifyDBClusterSnapshotAttributeOutput) String() string {
	return awsutil.Prettify(s)
}

const opModifyDBClusterSnapshotAttribute = "ModifyDBClusterSnapshotAttribute"

// ModifyDBClusterSnapshotAttributeRequest returns a request value for making API operation for
// Amazon DocumentDB with MongoDB compatibility.
//
// Adds an attribute and values to, or removes an attribute and values from,
// a manual DB cluster snapshot.
//
// To share a manual cluster snapshot with other AWS accounts, specify restore
// as the AttributeName, and use the ValuesToAdd parameter to add a list of
// IDs of the AWS accounts that are authorized to restore the manual cluster
// snapshot. Use the value all to make the manual cluster snapshot public, which
// means that it can be copied or restored by all AWS accounts. Do not add the
// all value for any manual DB cluster snapshots that contain private information
// that you don't want available to all AWS accounts. If a manual cluster snapshot
// is encrypted, it can be shared, but only by specifying a list of authorized
// AWS account IDs for the ValuesToAdd parameter. You can't use all as a value
// for that parameter in this case.
//
//    // Example sending a request using ModifyDBClusterSnapshotAttributeRequest.
//    req := client.ModifyDBClusterSnapshotAttributeRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/docdb-2014-10-31/ModifyDBClusterSnapshotAttribute
func (c *Client) ModifyDBClusterSnapshotAttributeRequest(input *ModifyDBClusterSnapshotAttributeInput) ModifyDBClusterSnapshotAttributeRequest {
	op := &aws.Operation{
		Name:       opModifyDBClusterSnapshotAttribute,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &ModifyDBClusterSnapshotAttributeInput{}
	}

	req := c.newRequest(op, input, &ModifyDBClusterSnapshotAttributeOutput{})

	return ModifyDBClusterSnapshotAttributeRequest{Request: req, Input: input, Copy: c.ModifyDBClusterSnapshotAttributeRequest}
}

// ModifyDBClusterSnapshotAttributeRequest is the request type for the
// ModifyDBClusterSnapshotAttribute API operation.
type ModifyDBClusterSnapshotAttributeRequest struct {
	*aws.Request
	Input *ModifyDBClusterSnapshotAttributeInput
	Copy  func(*ModifyDBClusterSnapshotAttributeInput) ModifyDBClusterSnapshotAttributeRequest
}

// Send marshals and sends the ModifyDBClusterSnapshotAttribute API request.
func (r ModifyDBClusterSnapshotAttributeRequest) Send(ctx context.Context) (*ModifyDBClusterSnapshotAttributeResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &ModifyDBClusterSnapshotAttributeResponse{
		ModifyDBClusterSnapshotAttributeOutput: r.Request.Data.(*ModifyDBClusterSnapshotAttributeOutput),
		response:                               &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// ModifyDBClusterSnapshotAttributeResponse is the response type for the
// ModifyDBClusterSnapshotAttribute API operation.
type ModifyDBClusterSnapshotAttributeResponse struct {
	*ModifyDBClusterSnapshotAttributeOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// ModifyDBClusterSnapshotAttribute request.
func (r *ModifyDBClusterSnapshotAttributeResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
