// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package lexruntimeserviceiface provides an interface to enable mocking the Amazon Lex Runtime Service service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package lexruntimeserviceiface

import (
	"github.com/aws/aws-sdk-go-v2-0.24/service/lexruntimeservice"
)

// ClientAPI provides an interface to enable mocking the
// lexruntimeservice.Client methods. This make unit testing your code that
// calls out to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // Amazon Lex Runtime Service.
//    func myFunc(svc lexruntimeserviceiface.ClientAPI) bool {
//        // Make svc.DeleteSession request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := lexruntimeservice.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockClientClient struct {
//        lexruntimeserviceiface.ClientPI
//    }
//    func (m *mockClientClient) DeleteSession(input *lexruntimeservice.DeleteSessionInput) (*lexruntimeservice.DeleteSessionOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockClientClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type ClientAPI interface {
	DeleteSessionRequest(*lexruntimeservice.DeleteSessionInput) lexruntimeservice.DeleteSessionRequest

	GetSessionRequest(*lexruntimeservice.GetSessionInput) lexruntimeservice.GetSessionRequest

	PostContentRequest(*lexruntimeservice.PostContentInput) lexruntimeservice.PostContentRequest

	PostTextRequest(*lexruntimeservice.PostTextInput) lexruntimeservice.PostTextRequest

	PutSessionRequest(*lexruntimeservice.PutSessionInput) lexruntimeservice.PutSessionRequest
}

var _ ClientAPI = (*lexruntimeservice.Client)(nil)
