// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package pricingiface provides an interface to enable mocking the AWS Price List Service service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package pricingiface

import (
	"github.com/aws/aws-sdk-go-v2-0.24/service/pricing"
)

// ClientAPI provides an interface to enable mocking the
// pricing.Client methods. This make unit testing your code that
// calls out to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // AWS Pricing.
//    func myFunc(svc pricingiface.ClientAPI) bool {
//        // Make svc.DescribeServices request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := pricing.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockClientClient struct {
//        pricingiface.ClientPI
//    }
//    func (m *mockClientClient) DescribeServices(input *pricing.DescribeServicesInput) (*pricing.DescribeServicesOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockClientClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type ClientAPI interface {
	DescribeServicesRequest(*pricing.DescribeServicesInput) pricing.DescribeServicesRequest

	GetAttributeValuesRequest(*pricing.GetAttributeValuesInput) pricing.GetAttributeValuesRequest

	GetProductsRequest(*pricing.GetProductsInput) pricing.GetProductsRequest
}

var _ ClientAPI = (*pricing.Client)(nil)
